// Orginal-Programm unter http://download.shamangrad.net/zcad/ttf2vector.7z

unit glyphview_Mod_FR;

{$mode objfpc}{$H+}

interface

uses
  EasyLazFreeType, TTObjs, TTTypes, Classes, SysUtils, FileUtil, Forms,
  Controls, Graphics, Dialogs, Spin, Menus, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  private
    FTTFFont:TFreeTypeFont;
    { private declarations }
  public
    { public declarations }
  end;
const
 // Position zum Zeichnen des Chars
 OriginX=80;
 OriginY=350;

 SymbolH=1;
var
  Form1: TForm1;
  hauptpfad:string;

implementation

{$R *.lfm}

{ TForm1 }

// TTF-Freetype-Font erzeugen
procedure TForm1.FormCreate(Sender: TObject);
begin
  hauptpfad:=extractfiledir(paramstr(0));

  FTTFFont:=TFreeTypeFont.create;
  FTTFFont.Hinted:=false;
  FTTFFont.Name:=hauptpfad+'\FreeSans.ttf';
  caption:=FTTFFont.Name;
  spinedit1.MaxValue:=FTTFFont.GlyphCount-1;
end;

// Font auswählen
procedure TForm1.Button1Click(Sender: TObject);
begin
 opendialog1.InitialDir:=hauptpfad+'\fonts';
 opendialog1.Filter:='*.ttf';
 if opendialog1.Execute
  then
   FTTFFont.Name:=opendialog1.FileName
  else
   FTTFFont.Name:=hauptpfad+'\FreeSans.ttf';

 caption:=FTTFFont.Name;
 // Zeichnen
 invalidate;
end;

// Index eines Uni-Code-Zeichen's finden
procedure TForm1.Button2Click(Sender: TObject);
var s:widestring;
    c:PUniCodeChar;
begin
 s:=edit1.text;
 c:=@s[1];
 spinedit1.Value:=ord(c^);
end;

// Font grob zeichnen
procedure TForm1.FormPaint(Sender: TObject);
var
 glyph:TFreeTypeGlyph;
 _glyph:PGlyph;

 j:integer;
 x,y,x1,y1,scx,scy:double;
 cends,lastoncurve:integer;
 startcountur:boolean;
 k:double;
 bounds:trect;
 oldbrushcolor:tcolor;
 Hinweistext:string;

 Const
  psize=4; // Größe der Markierungspunkte

  // wenn ein Punkt exakt auf der Kontur liegt
  procedure POnCurve(x,y:double;color:tcolor);
  var
   Bounds:TRect;
  begin
   oldbrushcolor:=canvas.Brush.Color;
   canvas.Brush.Color:=color;
   bounds.BottomRight.x:=round(OriginX+x-psize);
   bounds.BottomRight.y:=round(Originy+SymbolH-y+psize);
   bounds.TopLeft.x:=bounds.BottomRight.x+2*psize;
   bounds.TopLeft.y:=bounds.BottomRight.y-2*psize;
   canvas.Rectangle(Bounds);
   canvas.Brush.Color:=oldbrushcolor;
  end;

  // Wenn es eine Bezier-Stützstelle ist
  procedure PNotOnCurve(x,y:double;color:tcolor);
  var
   Bounds:TRect;
  begin
   oldbrushcolor:=canvas.Brush.Color;
   canvas.Brush.Color:=color;
   bounds.BottomRight.x:=round(OriginX+x-psize);
   bounds.BottomRight.y:=round(Originy+SymbolH-y+psize);
   bounds.TopLeft.x:=bounds.BottomRight.x+2*psize;
   bounds.TopLeft.y:=bounds.BottomRight.y-2*psize;
   canvas.Ellipse(Bounds);
   canvas.Brush.Color:=oldbrushcolor;
  end;

  // Verbindungslinie zeichnen
  procedure TTFLine(x,y,x2,y2:double);
  begin
   x:=OriginX+x;
   y:=Originy+SymbolH-y;
   x2:=OriginX+x2;
   y2:=Originy+SymbolH-y2;
   canvas.line(round(x),round(y),round(x2),round(y2));
  end;

begin
 Hinweistext:='';

 k:=(FTTFFont.Ascent+FTTFFont.Descent+FTTFFont.LineSpacing)/FTTFFont.SizeInPixels;
 k:=SymbolH*k/FTTFFont.SizeInPixels;

 glyph:=FTTFFont.Glyph[FTTFFont.CharIndex[SpinEdit1.Value]];
 _glyph:=glyph.Data.z;

 cends:=0;
 lastoncurve:=0;
 startcountur:=true;
 memo1.Clear;
 memo1.Lines.add('glyph.Advance='+floattostr(glyph.Advance));
 memo1.lines.add('glyph.Bounds='+
                  inttostr(glyph.Bounds.Left)+' , '+
                  inttostr(glyph.Bounds.top)+' , '+
                  inttostr(glyph.Bounds.Right)+' , '+
                  inttostr(glyph.Bounds.Bottom));

 memo1.Lines.add('glyph.outline.Anzahl der Konturen='+inttostr(_glyph^.outline.n_contours));
 memo1.lines.add('glyph.outline.Metrics.box='+
                  inttostr(_glyph^.metrics.bbox.xMin)+' , '+
                  inttostr(_glyph^.metrics.bbox.yMin)+' , '+
                  inttostr(_glyph^.metrics.bbox.xMax)+' , '+
                  inttostr(_glyph^.metrics.bbox.yMax));

 for j:=0 to _glyph^.outline.n_points do
  begin
   sleep(spinedit2.Value);
   application.ProcessMessages;

   x1:=_glyph^.outline.points^[j].x div 3;
   y1:=_glyph^.outline.points^[j].y div 3;

   if (_glyph^.outline.flags^[j] and TT_Flag_On_Curve)<>0
    then
     // Punkte auf Kontur
     begin
      POnCurve(x1,y1,clgreen);
      hinweistext:='Kontur-Punkt clgreen';
     end
    else
     begin
      // Bezier-Stützpunkte
      PNotOnCurve(x1,y1,clred);
      hinweistext:='Bezier-Punkt clred';
     end;
   if  startcountur
    then
     // Startpunkt
     begin
      scx:=x1;
      scy:=y1;
      POnCurve(x1,y1,clyellow);
      startcountur:=false;
      hinweistext:='Start-Punkt clyellow';
     end
    else
     begin
      if (_glyph^.outline.flags^[j] and TT_Flag_On_Curve)<>0
       then
        begin
         if j-lastoncurve>3
          then lastoncurve:=lastoncurve;
         lastoncurve:=j;
        end;
       begin
        TTFLine(x1,y1,x,y);
       end;
      if j=_glyph^.outline.conEnds^[cends]
       then
        begin
         inc(cends);
         startcountur:=true;
         lastoncurve:=j+1;
         TTFLine(x1,y1,scx,scy); // letzte linie zurück zum Startpunkt
         POnCurve(x1,y1,cllime);
         hinweistext:='End-Punkt cllime';
         if cends=_glyph^.outline.n_contours
          then
           begin
            memo1.Lines.add(hinweistext);
            memo1.Lines.add('glyph.outline.Pos XY='+
                    inttostr(_glyph^.outline.points^[j].x)+' , '+
                    inttostr(_glyph^.outline.points^[j].y) );
            break;
           end;
        end;
     end;

   // Koordinatenausgabe
   if hinweistext='Start-Punkt clyellow'
    then
     memo1.Lines.add('');
    memo1.Lines.add(hinweistext);
    memo1.Lines.add('glyph.outline.Pos XY='+inttostr(_glyph^.outline.points^[j].x)+' , '+
                                            inttostr(_glyph^.outline.points^[j].y) );


   x:=x1;
   y:=y1;
  end; // for j
end;


procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  invalidate;
end;

end.

